/*
 * Copyright 2022 The Furiko Authors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

// Code generated by informer-gen. DO NOT EDIT.

package v1alpha1

import (
	"context"
	time "time"

	executionv1alpha1 "github.com/furiko-io/furiko/apis/execution/v1alpha1"
	versioned "github.com/furiko-io/furiko/pkg/generated/clientset/versioned"
	internalinterfaces "github.com/furiko-io/furiko/pkg/generated/informers/externalversions/internalinterfaces"
	v1alpha1 "github.com/furiko-io/furiko/pkg/generated/listers/execution/v1alpha1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	runtime "k8s.io/apimachinery/pkg/runtime"
	watch "k8s.io/apimachinery/pkg/watch"
	cache "k8s.io/client-go/tools/cache"
)

// JobConfigInformer provides access to a shared informer and lister for
// JobConfigs.
type JobConfigInformer interface {
	Informer() cache.SharedIndexInformer
	Lister() v1alpha1.JobConfigLister
}

type jobConfigInformer struct {
	factory          internalinterfaces.SharedInformerFactory
	tweakListOptions internalinterfaces.TweakListOptionsFunc
	namespace        string
}

// NewJobConfigInformer constructs a new informer for JobConfig type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewJobConfigInformer(client versioned.Interface, namespace string, resyncPeriod time.Duration, indexers cache.Indexers) cache.SharedIndexInformer {
	return NewFilteredJobConfigInformer(client, namespace, resyncPeriod, indexers, nil)
}

// NewFilteredJobConfigInformer constructs a new informer for JobConfig type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewFilteredJobConfigInformer(client versioned.Interface, namespace string, resyncPeriod time.Duration, indexers cache.Indexers, tweakListOptions internalinterfaces.TweakListOptionsFunc) cache.SharedIndexInformer {
	return cache.NewSharedIndexInformer(
		&cache.ListWatch{
			ListFunc: func(options v1.ListOptions) (runtime.Object, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.ExecutionV1alpha1().JobConfigs(namespace).List(context.TODO(), options)
			},
			WatchFunc: func(options v1.ListOptions) (watch.Interface, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.ExecutionV1alpha1().JobConfigs(namespace).Watch(context.TODO(), options)
			},
		},
		&executionv1alpha1.JobConfig{},
		resyncPeriod,
		indexers,
	)
}

func (f *jobConfigInformer) defaultInformer(client versioned.Interface, resyncPeriod time.Duration) cache.SharedIndexInformer {
	return NewFilteredJobConfigInformer(client, f.namespace, resyncPeriod, cache.Indexers{cache.NamespaceIndex: cache.MetaNamespaceIndexFunc}, f.tweakListOptions)
}

func (f *jobConfigInformer) Informer() cache.SharedIndexInformer {
	return f.factory.InformerFor(&executionv1alpha1.JobConfig{}, f.defaultInformer)
}

func (f *jobConfigInformer) Lister() v1alpha1.JobConfigLister {
	return v1alpha1.NewJobConfigLister(f.Informer().GetIndexer())
}
